<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>

  <meta content="text/html; charset=ISO-8859-1"
 http-equiv="content-type">
  <title>DCS7 Parameters</title>
</head>
<body style="background-color: rgb(192, 192, 192); color: rgb(0, 0, 0);"
 alink="#ee0000" link="#0000ee" vlink="#551a8b">
<div style="text-align: center;">
<h1>DCS7 Parameters</h1>
<div style="text-align: left;">
<ul id="mozToc">
<!--mozToc h3 1 h4 2 h5 3--><li><a href="#mozTocId145356">Introduction</a></li>
  <li><a href="#mozTocId674854">Common
Parameters</a></li>
  <li><a href="#mozTocId42455">Device
Parameters
    </a>
    <ul>
      <li><a href="#mozTocId924428">SPI
Parameters</a></li>
      <li><a href="#mozTocId340094">I2C
Parameters</a></li>
      <li><a href="#mozTocId872883">UART
Parameters</a></li>
    </ul>
  </li>
  <li><a href="#mozTocId916740">Description</a>
    <ul>
      <li><a href="#mozTocId363240">Command
processing</a></li>
      <li><a href="#mozTocId414591">Flow
Control</a></li>
      <li><a href="#mozTocId216394">Device
Error Handling</a></li>
    </ul>
  </li>
  <li><a href="#mozTocId863376">References</a></li>
</ul>
<h3><a class="mozTocH3" name="mozTocId145356"></a><a id="Intro"
 name="Introduction"></a>Introduction</h3>
DCS7 module provides the ability to
control the PA software running on the K2G and also obtain status
information about the PA system. This document describes the
configurability provided by the DCS7 module via parameterization in <cite>dcs7_params.c<a
 href="#References_"><sup>[1]</sup></a></cite>
and <cite>dcs7_params.h<a href="#References_"><sup>[2]</sup></a></cite>
implementation files. The
hardware setup required for demonstrating DCS7 functionality is
described in detail
in <em>DCS7 Hardware Setup<a href="#References_"><sup>[3]</sup></a></em>.
The transport protocols used by the different DCS7 modes of
communication are described in <em>DCS7
Transport Protocol<a href="#References_"><sup>[4]</sup></a></em>.
<br>
<br>
<h3><a class="mozTocH3" name="mozTocId674854"></a><a id="CP"
 name="Common_Parameters"></a>Common
Parameters</h3>
The DCS7 module provides configurability in two forms namely common
parameters and device specific parameters. The DCS7 common parameters
are described here and the device specific parameters are introduced in
the subsequent sections. The DCS7 module provides the system
integrator the ability to control the DCS7 behavior via the <em>DCS7_Params</em>
structure:<br>
<br>
<div style="margin-left: 40px;"><code>typedef
struct DCS7_Params{<br>
&nbsp;&nbsp;&nbsp; Uint32
size;&nbsp;&nbsp;&nbsp; /* size of the structure */<br>
&nbsp;&nbsp;&nbsp; Uint8
dev;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* device */<br>
&nbsp;&nbsp;&nbsp; Uint8
edr;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* error
detection and reporting */<br>
&nbsp;&nbsp;&nbsp; Uint8
res[2];&nbsp;&nbsp; /* reserved */<br>
&nbsp;&nbsp;&nbsp; Uint16
rxSize;&nbsp; /* receive buffer size */<br>
&nbsp;&nbsp;&nbsp; Uint16
rxHwm;&nbsp;&nbsp; /* receive buffer high watermark */<br>
&nbsp;&nbsp;&nbsp; Uint16
rxLwm;&nbsp;&nbsp; /* receive buffer low watermark */<br>
&nbsp;&nbsp;&nbsp; Uint16
txSize;&nbsp; /* transmit buffer size */<br>
&nbsp;&nbsp;&nbsp; DCS7_Params_Dev
*pDev;&nbsp;&nbsp;&nbsp; /* device parameters */<br>
}DCS7_Params;<br>
&nbsp;</code><span style="font-style: italic;"><br>
</span></div>
The different parameters and the supported options are explained
below:<br>
<ul>
  <li><span style="font-weight: bold;">size </span>-<span
 style="font-weight: bold;"> </span>size
of the <var>DCS7_Params</var>
structure.</li>
  <li><span style="font-weight: bold;">dev </span>-<span
 style="font-weight: bold;"> </span>device
used for
communication. The DCS7 module supports 1 instances of SPI namely <em>DCS7_PARAMS_DEV_SPI0</em>,
1 instances of I2C namely <em>DCS7_PARAMS_DEV_I2C0</em> and 1 instances of UART namely <em>DCS7_PARAMS_DEV_UART0</em>.<br>
  </li>
  <li><span style="font-weight: bold;">edr </span>-<span
 style="font-weight: bold;"> </span>error
detection
and reporting. The DCS7 module provides the ability to detect and
report error conditions for certain devices. For information on the
different error conditions&nbsp; refer the particular device
parameters. This feature can be enabled by choosing <em>DCS7_PARAMS_EDR_ENA</em>
option and disabled by choosing <em>DCS7_PARAMS_EDR_DIS</em>
option.</li>
  <li><span style="font-weight: bold;">rxSize </span>-<span
 style="font-weight: bold;"> </span>receive
buffer
size. The receive buffer size can be configured depending upon the
available memory, application memory requirements, communication
payload size, communication data rate, etc. The rxSize parameter
provides the ability to fine tune the communication channel performance
for a particular application.</li>
  <li><span style="font-weight: bold;">rxHwm </span>-<span
 style="font-weight: bold;"> </span>receive
buffer
high watermark. The DCS7 module provides communication flow control
capability by using receive buffer watermarks. This flow control
capability is in addition to and different from the flow control
capability provided by
the underlying device. The DCS7 module accepts data from the master as
long as there is sufficient space in the receive buffer. When the free
space available in the receive buffer falls below the level specified
by receive buffer high watermark (<var>rxHwm</var>)
the DCS7 module
cannot accept any more
data and this is indicated to the master by using the flow control
mechanism of the device in use. The slave then processes the data
available in the receive buffer and consequently free's up space for
writing new data. Once the free space available in the receive buffer
rises above the level indicated by receive buffer low watermark (<var>rxLwm</var>)
the
DCS7 module is ready to accept new data from the master and this is
indicated to the master by using the flow control mechanism of the
underlying device.</li>
  <li><span style="font-weight: bold;">rxLwm </span>-<span
 style="font-weight: bold;"> </span>receive
buffer low watermark.
Refer the description for <var>rxHwm</var> parameter above to know how
the
watermarks provide additional flow control capability.</li>
  <li><span style="font-weight: bold;">txSize </span>-<span
 style="font-weight: bold;"> </span>transmit
buffer size. The transmit
buffer size can be configured taking into account the total memory
available, application memory requirements, communication response
payload size,&nbsp; communication data rate, etc. The txSize
parameter
provides the ability to fine tune the communication channel performance
for a particular application.</li>
  <li><span style="font-weight: bold;">pDev </span>-<span
 style="font-weight: bold;"> </span>device
parameters. This field
provides a reference to the parameters for the underlying device as
specified by the <var>dev</var>
parameter above. Refer the particular
device
parameter description below for more information.</li>
</ul>
<h3><a class="mozTocH3" name="mozTocId42455"></a><a id="DP"
 name="Device_Parameters"></a>Device
Parameters<br>
</h3>
<h4><a class="mozTocH4" name="mozTocId924428"></a><a id="SP"
 name="SPI_Parameters"></a>SPI
Parameters</h4>
The DCS7 module allows the system integrator to control the SPI device
configuration through the following parameters:<br>
<br>
<div style="margin-left: 40px;"><code>typedef
struct
DCS7_Params_Dev_Spi{<br>
&nbsp;&nbsp;&nbsp; Uint32
size;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* size of the structure */<br>
&nbsp;&nbsp;&nbsp; Uint8 np;&nbsp; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* number of pins */<br>
&nbsp;&nbsp;&nbsp; Uint8 enahiz;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* SPIENA pin mode */<br>
&nbsp;&nbsp;&nbsp; Uint32 emask;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* error mask */<br>
&nbsp;&nbsp;&nbsp; SPI_Handle
hSpi;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* handle to SPI lld */<br>
&nbsp;&nbsp;&nbsp; SPI_Params
*spiParams;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /*
SPI Initialization param */<br>
&nbsp;&nbsp;&nbsp; SPI_Transaction
transaction;&nbsp;&nbsp;&nbsp; /* SPI transfer info */<br>
}DCS7_Params_Dev_Spi;<br>
<br>
</code><span style="font-weight: bold;"></span></div>
The parameters specified here are applicable for all instances of the
SPI device. The individual parameters are described below:<br>
<ul>
  <li><span style="font-weight: bold;"><strong>size</strong> </span>-<span
 style="font-weight: bold;"> </span>size
of the parameter structure.
This field should be set to the size of the <var>DCS7_Params_Dev_Spi</var>
structure.</li>
<li><strong>np </strong>- SPI number of pins. TBD.</li>
<li><strong>enahiz </strong>- SPIENA signal status when not active. TBD.</li>
<li><strong>emask </strong>- SPI error mask.</li>
  <li><span style="font-weight: bold;"><strong>hSpi</strong> </span>-<span
 style="font-weight: bold;">&nbsp; </span>Handle of SPI instance used by low level SPI driver. This parameter is initialized when the SPI instance is configured and opened by DCS. By default set it to NULL.</li>
  <li><strong><span style="font-weight: bold;">*spiParams</span></strong>
-<span style="font-weight: bold;"> </span>Pointer to SPI parameters used to configure the operation.</li>
  <ul>
    <li><em>transferMode</em><span
 style="font-weight: bold; font-style: italic;"> </span><span
 style="font-style: italic;">-</span><span
 style="font-weight: bold; font-style: italic;"> </span>Controls the low level driver transfer operation mode. SPI_MODE_BLOCKING (blocks execution) and SPI_MODE_CALLBACK (does not block code execution and will call transferCallbackFxn)</li>
    <li><em>transferTimeout</em><span
 style="font-weight: bold; font-style: italic;"> </span><span
 style="font-style: italic;">-</span><span
 style="font-weight: bold; font-style: italic;"> </span>Controls the low level driver transfer timeout.</li>
    <li><em>transferCallbackFxn </em>-<em> </em>Callback function pointer used in SPI_MODE_CALLBACK transfer mode.</li>
    <li><em>mode </em>- Control the SPI mode of operation as SPI slave or master. By default set it to SPI_SLAVE.</li>
    <li><em>bitRate </em>- SPI bit rate in Hz.</li>
    <li><em>dataSize </em>- SPI data frame size in bits (8 or 16).</li>
    <li><em>frameFormat </em>- Controls polarity and phase of SPI. Can have the following values SPI_POL0_PHA0, SPI_POL0_PHA1, SPI_POL1_PHA0, SPI_POL1_PHA1, SPI_TI (TI mode) and SPI_MW (Micro-wire mode) </li>
    <li><em>*custom </em>- Custom argument used by driver implementation. Not used, set it to NULL.</li>
  </ul>
  <li><strong>transaction </strong>- SPI transfer info. Used for SPI low level driver. Set it to {0, NULL, NULL, NULL}.</li>
</ul>
For more details on the SPI device and the different aspects of the SPI
device that are configured by the parameters above refer the K2G SPI
User Guide and K2G PDK's SPI LLD documentation.<br>
<h4><a class="mozTocH4" name="mozTocId340094"></a><a id="I2CP"
 name="I2C_Parameters"></a>I2C
Parameters</h4>
The DCS7 module allows the system integrator to control the I2C device
configuration through the following parameters:<br>
<br>
<div style="margin-left: 40px;"><code>typedef
struct
DCS7_Params_Dev_I2c{</code><br>
<code>&nbsp;&nbsp;&nbsp;
Uint32 size;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* size of the
structure */</code><br>
<code>&nbsp;&nbsp;&nbsp;
I2C_Handle hI2c;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* handle to I2C lld */</code><br>
<code>&nbsp;&nbsp;&nbsp;
I2C_Params i2cParams;&nbsp;&nbsp; /* I2C Initialization parameters */</code><br>
<code>&nbsp;&nbsp;&nbsp;
I2C_Transaction transaction;&nbsp;&nbsp;&nbsp; /* I2C transfer info */</code><br>
<code>&nbsp;&nbsp;&nbsp;
Uint8 ownSlaveAddress;&nbsp; /* Own slave address */</code><br>
<code>&nbsp;&nbsp;&nbsp;
Uint8 reserved[3];&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* reserved */</code><br>
<code>&nbsp;&nbsp;&nbsp;
Uint32 emask;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/* Error mask */</code><br>
<code>}DCS7_Params_Dev_I2c;<br> 
<br>
</code></div>
The parameters specified here are applicable for all instances of the
I2C device. The individual parameters are described below:<br>
<ul>
  <li><strong>size </strong>- size of the parameter
structure. This
field should be set to the size of the <var>DCS7_Params_Dev_I2c</var>
structure.</li>
  <li><strong>hI2c </strong>- Handle of I2C instance used by low level I2C driver. This parameter is initialized when the I2C instance is configured and opened by DCS. By default set it to NULL.</li>
  <li><strong>i2cParams </strong>- I2C parameters used to configure the operation.</li>
  <ul>
  <li><em>transferMode </em>-<em> </em>Controls the low level driver transfer operation mode. I2C_MODE_BLOCKING (blocks execution) and I2C_MODE_CALLBACK (does not block code execution and will call transferCallbackFxn).</li>
    <li><em>*transferCallbackFxn </em>- Pointer to callback function.</li>
    <li><em>bitRate </em>- I2C bus bit rate. One of the following I2C_100kHz, I2C_400kHz or I2C_3P4Mhz.</li>
    <li><em>*custom </em>- Custom argument used by driver implementation. Not used.</li>
    <li><em>isSlave </em>- Control the SPI mode of operation as SPI slave or master. By default set it to I2C_SLAVE.</li>
  </ul>
  <li><strong>transaction </strong>- I2C transfer info. Used for I2C low level driver. Set it to {NULL, 0, NULL, 0, 0, NULL, NULL}.</li>
  <li><strong>ownSlaveAddress </strong>- Own slave address.</li>
  <li><strong>reserved[3] </strong>- reserved.</li>
  <li><strong>emask </strong>- I2C error mask.</li>
</ul>
For more details on the I2C device and the different aspects of the I2C
device that are configured by the parameters above refer the K2G I2C
User Guide and K2G PDK's I2C LLD documentation.<br>
<h4><a class="mozTocH4" name="mozTocId872883"></a><a id="UARTP"
 name="UART_Parameters"></a>UART
Parameters</h4>
The DCS7 module supports UART communication using 1 <em>START</em>
bit, 8 <em>DATA</em>
(ascii) bits, no <em>PARITY</em>
bit and 1 <em>STOP</em>
bit. The DCS7
module uses the UART data pins (<em>UART_TXD,
UART_RXD</em>) for
communication. The <em>UART_CTS</em>
and <em>UART_RTS</em>
pins are
not used for handshaking.
The communication baud rate is configurable and can be set to the
desired rate using the parameters described below.<br>
<br>
The DCS7 module allows
the system integrator to control the UART device
configuration through the following parameters:<br>
<br>
<div style="margin-left: 40px;"><samp>typedef
struct DCS7_Params_Dev_Uart{</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint32 size;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* size of the structure */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint32 emask;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* error mask */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
UART_Handle hUart;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* handle to UART lld */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
UART_Callback transferCallbackFxn;&nbsp;&nbsp;&nbsp;&nbsp; /*  function pointer to handle the transfer operations routine */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint16 isEMDAConfigured;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* Flag to indicate EDMA configuration completion. */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint16 scratchBufSize; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;/* Sratch buffer size allocated for internal operation */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint8 *scratchBuf; &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* Sratch buffer allocated for internal operation */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
UART_Params uartParams;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* UART Initialization parameters */</samp><br>
<samp>&nbsp;&nbsp;&nbsp;
Uint32 baudRate;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; /* UART baudrate */</samp><br>
<samp>}DCS7_Params_Dev_Uart;<br>
<br>
</samp><samp></samp></div>
The parameters specified here are applicable for all instances of the
UART device. The individual parameters are described below:<br>
<ul>
  <li><strong>size
- </strong>size of the parameter
structure. This field should be set to the size of the <var>DCS7_Params_Dev_Uart</var>
structure.</li>
  <li><strong>emask
- </strong>UART error mask.</li>
  <li><strong>hUart
- </strong> Handle of SPI instance used by low level SPI driver. This parameter is initialized when the SPI instance is configured and opened by DCS. By default set it to NULL.<br>
  </li>
  <li><strong>transferCallbackFxn
- </strong>Callback function pointer used when UART is configured to operate in callback transfer mode.</li>
  <li><strong>isEMDAConfigured
- </strong>Flag to indicate EDMA configuration completion. It is used internally, set it to 0 by default.</li>
  <li><strong>scratchBufSize
- </strong>Size of scratch buffer used internally. Depends upon the maximum transfer size.</li>
  <li><strong>*scratchBuf
- </strong>Pointer to scratch buffer allocated for internal operation.
  </li>
  <li><strong>uartParams
- </strong>Used for UART low level driver.</li>
  <li><strong>baudRate
-</strong> UART baudrate.
  </li>
  </ul>
</ul>
&nbsp; For more details on the UART device and the different
aspects of
the UART
device that are configured by the parameters above refer the K2G UART
User Guide and K2G PDK's UART LLD documentation.
<h3><a class="mozTocH3" name="mozTocId916740"></a><a id="Desc"
 name="Description"></a>Description</h3>
Some of the DCS7 parameters described above require more elaborate
discussion. This
sections provides more details on these topics.<br>
<h4><a class="mozTocH4" name="mozTocId216394"></a><a id="DEH"
 name="Device_Error_Handling"></a>Device
Error Handling</h4>
The DCS7 module provides the ability to detect certain device error
conditions, report the occurrence of device error to the master and
perform error recovery. <br>
<br>
The DCS7 module error handling is enabled by
using the option <a href="#Common_Parameters"><em>DCS7_PARAMS_EDR_ENA</em></a>
for the <a href="#Common_Parameters"><var>edr</var></a>
parameter and the different
device error conditions to detect are specified by the device specific <var>emask</var>
parameter. <br>
<br>
The DCS7 module provides the following API's to report the occurrence
of
the device error to the master
:<br>
<br>
<div style="margin-left: 40px;"><code>void
DCS7_errorInit()<br>
{<br>
&nbsp;&nbsp;&nbsp; /* Initialize the physical interface
that will be
used for reporting <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; error
occurrence to the master */<br>
}<br>
<br>
void DCS7_errorAssert()<br>
{<br>
&nbsp;&nbsp;&nbsp; /* Configure the physical interface to
indicate
occurrence of an error<br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; to the
master */ <br>
}<br>
void DCS7_errorDeassert()<br>
{<br>
&nbsp;&nbsp;&nbsp; /* Configure the physical interface to
indicate
error recovery is <br>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; completed
and the slave is ready
to accept new data */<br>
}<br>
<br>
</code></div>
The <em>DCS7_errorInit</em>
API is invoked during the DCS7 module
initialization sequence and the system integrator can use this API to
initialize and setup the physical interface.The physical interface
would typically be a general purpose output pin and this API can be
used to configure a general purpose pin in output mode.<br>
<br>
<code></code>The
<em>DCS7_errorAssert</em>
API is invoked when the
DCS7 module detects one or more device error conditions and the system
integrator can use this API to configure the physical interface to
indicate this to the master. Typically this API can be used to assert
the general purpose output pin to indicate occurrence of an error.<br>
<br>
The <em>DCS7_errorDeassert</em>
API is invoked after the DCS7 module
has taken proper action to recover from the error condition and the
system integrator can use this API to inform the master that the DCS7
module is ready to accept new data. Typically this API can be used to
de-assert the general purpose output pin to indicate that the device
has been reconfigured to accept new data.<br>
<br>
The DCS7 module performs error recovery by reseting and reconfiguring
the underlying device and there are no additional specific actions
taken for any particular device error.
<br>
<h3><a class="mozTocH3" name="mozTocId863376"></a><a id="Ref"
 name="References_"></a>References</h3>
<ol>
  <li><a href="dcs7_params.c">"dcs7_params.c", TI Performance
Audio</a></li>
  <li><a href="dcs7_params.h">"dcs7_params.h", TI Performance
Audio</a></li>
  <li><a href="dcs7_hwsetup.html">"DCS7 Hardware Setup", TI
Performance
Audio</a></li>
  <li><a href="dcs7_tp.html">"DCS7 Transport
Protocol",&nbsp; TI
Performance Audio.</a></li>
</ol>
<br>
</div>
</div>
</body>
</html>
